﻿# -*- coding: utf-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
import gtk, gobject

def _(m):
    return m


def cd2rd(f): #yyyymmddhhiiss -> dd/mm/yyyy hh:ii:ss
   if f:
      if len(f) == 14:
         return f[6:8]+"/"+f[4:6]+"/"+f[:4]+" "+f[8:10]+":"+f[10:12]+":"+f[12:14]
      else:
         return f[6:8]+"/"+f[4:6]+"/"+f[:4]
   else:
      return f

from datetime import datetime
def cd2d(f): #yyyymmddhhiiss -> datetime
   return datetime(int(f[:4]),int(f[4:6]), int(f[6:8]),int(f[8:10]),int(f[10:12]),int(f[12:14]))

def format_file_size_for_display(file_size):
    KILOBYTE_FACTOR = 1024.0
    MEGABYTE_FACTOR = 1024.0 ** 2
    GIGABYTE_FACTOR = 1024.0 ** 3

    if file_size < KILOBYTE_FACTOR:
        return _('%u bytes') % file_size
    if file_size < MEGABYTE_FACTOR:
        return _('%.1f KB') % (file_size/KILOBYTE_FACTOR)
    if file_size < GIGABYTE_FACTOR:
        return _('%.1f MB') % (file_size/MEGABYTE_FACTOR)
    return _('%.1f GB') % (file_size/GIGABYTE_FACTOR)


from subprocess import call,Popen
def runWith(l,file,wait=True):
    """ try command in the list 'l' with the file 'file' """
    assert type(file)==unicode
    for c in l:
        try:
            if wait:
                p = call([c,file])
            else:
                Popen([c,file])
        except OSError:
            pass
        else:
            return True
    return False

import os,sys
def openURL(url):
    """ open the url in the current browser (don't wait the browser)"""
    if sys.platform[:3].lower() == "win":
        os.startfile(url)
    else:
        runWith(["gnome-open","mozilla-firefox","firefox","konqueror","epiphany","galeon"],unicode(url),False)

# Class pictureselector
# This class provides a thumbnailview with a slider. It behaves as a normaol gtk class, and emits the signal "value_changed"
# whenever a user changes the slider

class PictureSelector(gtk.VBox):

    def __init__(self, photo_list):
        gtk.VBox.__init__(self)

        self.photo_list = photo_list

        #self.photo_list.sort(lambda f, s: int(int(s.date) - int(f.date))) # The integer cast is for the result is needed because the dates are usually of type long, and a comparison needs an int
        self.photo_list.sort(lambda f, s: cmp(s.date,f.date)) # manatlan was here

        # Create all the visual elements
        self.thumb_display = gtk.Image()
        self.slider        = gtk.HScrollbar()
        self.text_display  = gtk.Label("Photo 1/1")
        self.pack_start(self.thumb_display, expand = False)
        self.pack_start(self.slider, expand = True, fill = True)
        self.pack_start(self.text_display, expand = False)

        # Initialize the slider
        if (len(self.photo_list) > 1):
            self.slider.set_range(1, len(self.photo_list))
            self.slider.set_increments(1, 10)

        self.updateDisplay()
        # --Instead of this, wouldnt it make sense just to not show the slider?
        # Otherwise the photo looks ugly all grey. See below
        # --Daniel Patterson (dbpatterson@riseup.net) 12th June 2007

        # Create the callbacks
        self.slider.connect("value_changed", self.onSliderChange)

        # Display everything
        if (len(self.photo_list)>1):
            self.slider.show()        
        self.text_display.show()
        self.thumb_display.show()

    def onSliderChange(self, widget):
        # Update the display of the text widget and the thumbnail
        self.updateDisplay()

        # Emit a signal that we have changed
        self.emit("value_changed", self)

    def getValue(self):
        # Returns the index value of the photolist. Watch out for off-by-one errors!
        slider_value = int(self.slider.get_value())
        if (slider_value == 0):
            slider_value = 1
        return slider_value - 1

    def updateDisplay(self):
        photo_num = self.getValue()
        self.text_display.set_text("Photo %d/%d: %s" % (photo_num + 1, len(self.photo_list), self.photo_list[photo_num].name))
        self.thumb_display.set_from_pixbuf(self.photo_list[photo_num].getThumb())

    def set_sensitive(self, value):
        # Make the widget greyed out or active. If the photo list has only one picture, it can never be active
        if (value == True) and (len(self.photo_list) < 2):
            value = False

        if (value == True):
            gtk.VBox.set_sensitive(self, True)
        else:
            gtk.VBox.set_sensitive(self, False)

# Create the "value_changed" signal and connect it to the PictureSelector class
gobject.signal_new("value_changed", PictureSelector, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,))

if __name__ == "__main__":
    #~ print JBrout.home
    #~ JBrout.conf["jo"] = "hack"
    #~ print JBrout.conf["jo"]
    #~ JBrout.conf.save()
    runWith(["StaRT","geany"],u"toto",False)
    pass

